--$Name: Сектор-37$
--$Version: 0.3$
instead_version '1.9.0'

require 'modules/fonts'
require 'modules/paginator'
require 'modules/vn'
require 'dash'

if theme:name() ~= '.' then
	error "Пожалуйста, включите собственные темы для игр!"
end

f1 = font('fonts/{sans,sans-b,sans-i}.ttf', 18);
f2 = sprite.font('fonts/font-n.ttf', 50);

function pname(n, c)
	return function()
		pn(img 'blank:4x4',f1:txt(n, c, 1))
	end
end

anton = pname("Антон", "red")
serg = pname("Серега", "lightblue")
base = pname("База", "cyan")
yastreb = pname("Ястреб-5", "green")
enemy = pname("???", "red")

paginator.delim = '\n[ \t]*\n' -- выбор разделителя для переноса на разные страницы

stead.scene_delim = '^^'

function exec(s) -- вставки кода в вывод
	p('$'..s:gsub("\n", "^")..'$^^')
end

-- vn:scene() -- начало работы со сценой, 
-- очистка всех показанных персонажей
-- vn:scene('bg.png') -- выбрать фон
-- ВНИМАНИЕ! Реальное изменение вступит в
-- силу только после вызова
-- vn:start() -- запустить эффекты

-- ВНИМАНИЕ! В сцене должен быть фон, это значит
-- что в игре первый vn:scene всегда должен
-- задаваться фон!

-- эта функция обновляет изображение 
-- либо с помощью эффекта 'dissolve',
-- либо 'fading', либо моментально:

-- Примеры:
-- vn:start 'fading'
-- vn:start 'dissolve'
-- vn:start ()

-- Персонажи:
-- персонажи или объекты - просто именованные картинки,
-- создаются сл. образом:
-- pantel = image ('бомж1', 'Pantel_gru.png')
-- обратите внимание на имя 'бомж1' -- имя идентифицирует
-- картинку 

-- Внимание! Если у персонажа уникальная картинка,
-- то можно не использовать image, а просто вписывать путь к картинке,
-- например:
-- vn:show('Pantel_gru.png')

-- Показать персонаж:
-- ==================

-- vn:show(pantel, '[эффект-]позиция', [время в мс])

-- где _позиция_, комбинация слов:
-- left, right, center
-- top, bottom, middle
-- например: top-right = правый верхний угол
-- left-bottom - слева снизу
-- bottom - снизу в центре
-- также можно указывать абсолютные координаты левого верхнего угла как @x,y или
-- комбинировать: left-top@0,+200 (координата относительно левой верхней позиции)

-- _Эффект_ или отстутствует (в таком случае эффект показа
-- будет применено в момент vn:start как dissolve или fading или моментально.

-- или принимает одно из следующих значений:
-- moveinleft, moveinright, moveintop, moveinbottom, fadein, zoomin

-- ВНИМАНИЕ! Если задать эффект, например movein, но в vn:start() тоже
-- задан эффект перехода, то применится эффект заданные в vn:show, например:

-- vn:scene('bg.png')
-- vn:show(pantel, 'movein-left')
-- vn:start('fading') -- реально фейдинга не будет, бомж выедет с левой части экрана,

-- если вы хотите сначала fading а потом выезд бомжа, придется разбить на две операции:
-- vn:scene('bg.png')
-- vn:start('fading')
--
-- vn:show(pantel, 'movein-left')
-- vn:start();


-- Спрятать персонаж:
-- ==================

-- Убрать персонажа можно 
-- vn:hide(pantel)
-- если хочется с эффектом
-- vn:hide(pantel, [эффект], [время мc])
-- Эффектами могут быть:
-- fadeout, moveoutleft, moveoutright, moveouttop, moveoutbottom, zoomout
-- либо, например:
-- vn:hide (pantel)
-- vn:start 'dissolve'
-- уберется с эффектом 'dissolve'


-- Применение exec:
-- ===============
-- В одном exec может быть только один vn:start.
-- Но можно делать несколько exec в каждом из которых есть vn:start, например:
-- exec [[
-- vn:scene('bg.png')
-- vn:start('fading') ]]
--
-- exec [[ vn:show(pantel, 'movein-left')
-- vn:start(); ]]

-- пока все!


function init()
	vn.fading = 8
	vn:scene ('images/childs.jpg');
	vn:start 'dissolve';
	spr_title = sprite.text(f2, "СЕКТОР 37", 'white')
	spr_end = sprite.text(f2, "КОНЕЦ", 'white')
	set_music_fading (2000, 2000)
	set_music 'music/2.ogg'
	vn.textboxw = 800
	vn.textboxh = 120
end


main = vnr {
	dsc = function (s)
		anton()
		pn "-- Давай в прятки!"
		pn ()
		serg()
		pn "-- Здесь же негде прятаться?"
		pn()
		anton()
		pn "-- Давай! Будет интересно. Вот увидишь. Здесь можно прятаться везде!"
		pn ()
		serg()
		pn "-- Ну давай! Только, чур, ты водишь."
		pn()
		anton()
		pn "-- Ну нет, давай считаться!"
		pn ()
		serg()
		pn "-- Хорошо, но я считаю."
		pn ()
		pn "-- Раз два—три—четыре—пять,"
		pn "-- Будем—в прятки—мы—играть."
		pn ()
		pn "-- Небо—звёзды—луг—цветы"
		pn "-- Ты—пойди-ка—пово—ди!"
		pn ()
		pn "-- Тебе водить!"
		pn ()
		anton()
		pn "-- Ладно, я к дереву!"
		pn ()
		serg()
		pn "-- ... И не подсматривай!!!"
	end;
	walk_to = 'child2';
};


child2 = vnr {
	dsc = function (s)
		exec [[
			vn:scene ('box:800x600,black'); 
			vn:start('dissolve')
		]];
		pn "Этот день не выходит у меня из головы."
		pn ()
		pn "Мы играли до вечера, а потом..."
		pn ()
		pn "Пока шли усталые домой поклялись, что останемся друзьями..."
		pn ()
		exec [[
			vn:scene ('images/boys2.jpg'); 
			vn:start('dissolve')
		]];
		pn "На всю жизнь..."
		pn()
	end,
	walk_to = 'intro';
};

intro = vnr {
	dsc = function(s)
		exec [[
			set_music 'music/3.ogg'
			vn:scene ('images/planet.jpg')
			vn.fading = 32
			vn:start ('fading')
		]];
		exec [[
			vn:show(spr_title, 'fadein-center-middle@-8,0', 2000);
			vn:start ('fading')
		]];
		base()
		pn ".. Ястреб-5, Ястреб-5..."
		pn ();
		exec [[
			vn:hide(spr_title, 'fadeout', 2000);
			vn:start ('fading')
		]];
		base()
		pn ".. Ястреб-5, Ястреб-5..."
		pn ();
		pn "Мы засекли прорыв периметра в секторе 37."
		pn ();
		pn "Вероятнее всего -- штурмовик."
		pn ();
		pn "Боевая задача -- перехватить и уничтожить."
		pn ();
		pn "Подтвердите, как поняли."
		pn ();
	end;
	walk_to = 'inspace';
}

inspace = vnr {
	dsc = function(s)
		exec [[
			vn:show('images/fighter1.png', 'moveintop-right-top', 1000);
			vn:show('images/hemlet1.png', 'fadein-left-top@16,16', 1000);
			vn:start ()
		]];
		yastreb()
		pn "Вас понял, выполняю задачу."
		pn ()
		exec [[
			vn:hide('images/fighter1.png', 'moveoutleft', 500);
			vn:hide('images/hemlet1.png', 'fadeout', 500);
			vn:start ()
		]];
		yastreb()
		pn "...Интересно, на что они только надеятся, эти терры..."
		pn ()
	end;
	walk_to = 'inspace2';
}

inspace2 = vnr {
	dsc = function(s)
		exec [[
			vn:scene ('images/stars.jpg')
			vn.fading = 32
			vn:start 'fading'
		]];
		exec [[
			vn:show('images/hemlet1.png', 'fadein-right-top@-16,16', 1000);
			vn:start()
		]]
		yastreb()
		pn "-- База, я вижу его. Потрепанный Т3-17."
		pn ()
		pn "-- Мне кажется, он пуст. Наверное, пытался выбраться из окружения."
		pn ()
		pn "-- Попробую установить связь."
		pn ()
		base()
		pn "-- Хорошо, действуйте по ситуации."
		pn ()
		exec [[
			vn:show('images/fighter2.png', 'moveinleft-left-middle@16,100', 3000);
			vn:start()
		]]
		yastreb()
		pn "-- Эй, дружище, ты у меня на мушке!"
		pn ()
		pn "..."
		pn ()
		pn "-- Не делай вид, что у тебя сломана рация. Сдавайся, твоя война закончена!"
		pn ()
		pn "..."
		pn ()
		pn "-- Эй, тер, я знаю ты слышишь меня, сдавайся или я поджарю твое корыто."
		pn ()
		exec [[
			vn:show('images/hemlet2.png', 'fadein-left-top@16,16', 500);
			vn:start()
		]]
		enemy()
		pn "-- Смерть имперским выродкам!"
		pn ()
		yastreb()
		pn "-- Ага, значит с рацией у тебя все в порядке. Я даю тебе 10 секунд на принятие решения."
		pn ()
		pn "-- Через 10 секунд я посылаю ракеты. Ну же, сделай правильный выбор!"
		pn ()
		pn "-- 10.. 9.. 8.. 7.."
		pn ()
		exec [[
			vn:hide('images/fighter2.png', 'moveoutright', 500);
			vn:hide('images/hemlet2.png', 'fadeout', 500);
			vn:start()
		]]
		pn "-- Упертый малый..."
		pn ()
	end;
	walk_to = 'asteroids';
}

asteroids = vnr {
	dsc = function(s)
		exec [[
			vn:scene ('images/asteroids.jpg')
			vn.fading = 32
			vn:start()
		]];
		exec [[
			vn:show('images/hemlet1.png', 'fadein-right-top@-16,16', 1000);
			vn:start()
		]]
		yastreb()
		pn [[-- Ладно, я все-равно тебя найду. Твое сопротивление, как и других тебе подобных
			-- бессмысленно. ]]
		pn ()
--		exec [[
--			vn:hide('images/hemlet1.png', 'fadeout');
--			vn:start()
--		]]
	end;
	walk_to = 'asteroids2';
}

asteroids2 = vnr {
	dsc = function(s)
		exec [[
			vn:scene ('images/asteroids2.jpg')
			vn.fading = 32
			vn:start 'fading'
		]];
		pn [[... И все-же, не смотря на мое бахвальство, я все не мог его найти ...]]
		pn ()
		base()
		pn [[... Ястреб-5, Ястреб-5, доложите обстановку ...]];
		pn ()
		exec [[
			vn:show('images/hemlet1.png', 'fadein-right-top@-16,16', 1000);
			vn:start()
		]]
		yastreb()
		pn [[-- Он скрылся в астероидном поле, но я достану его...]]
		pn ()
		base()
		pn [[...Ястреб-5, будьте осторожны...]];
		pn ()
		yastreb()
		pn [[-- Хорошо, я осторожен...]]
		pn ()
		pn [[-- Ну, приятель...]]
		pn ()
		pn [[Раз два—три—четыре—пять,]]
		pn ()
		pn [[Будем—в прятки—мы—играть.]]
		pn ()
		pn "..."
		pn ()
		exec [[
			set_music 'music/5.ogg'
			vn:show('images/hemlet2.png', 'fadein-left-top@16,16', 500);
			vn:start()
		]]
		enemy()
		pn [[Небо—звёзды—луг—цветы]]
		pn [[Ты—пойди-ка—пово—ди!]]
		pn ()
	end;
	walk_to = 'dialog1';
}

dialog1 = dlg {
	nam = 'диалог';
	phr = {
		{"-- Сергей?",
		 "-- Да, это я, Антон.",
		 [[ pjump 't2' ]],
		},
		{"-- Откуда ты знаешь эту считалочку?", 
		 "-- Оттуда же, откуда ее знаешь ты, Антон.",
		 [[ pjump 't2' ]],
		},
		{},
		{ tag = 't2', 
		  "-- Как же так получилось, дружище?",
		  "-- Теперь мы не друзья.",
		  [[ pjump 't3' ]],
		},
		{
		  "-- Как же так получилось, что ты стал терром?", 
		  "-- Лучше скажи, как вышло, что ты продал свою совесть империи?",
		  [[ pjump 't3' ]],
		},
		{},
		{ tag = 't3';
		  empty = function(s)
			pjump 't4';
		  end;
		},
		{
		  "-- Ты помнишь клятву?",
		  "-- Да, но теперь у меня другая клятва.",
		},
		{
		  "-- Я не могу поверить...",
		  "-- Мне тоже сложно видеть тебя в роли имперского аса."
		},
		{},
		{
		 tag = 't4';
		 "-- Хорошо, что нам делать?",
		 "-- ... Не знаю ... Хотя я, кажется, принял решение.",
		 [[ pjump 't5' ]];
		},
		{
		 "-- Я должен тебя убить.",
		 "-- Хорошо, давай закончим с этим.",
		 [[ pjump 't6' ]];
		},
		{ 
		 "-- Ты точно не хочешь сдаться?",
		 "-- Это исключено.", 
		},
		{},
		{ tag = 't5';
		"-- И что ты предлагаешь?",
		"-- Сейчас я взлечу с астероида и буду драться.",
			code = [[ walk 'battle' ]];
		},
		{},
		{ tag = 't6',
		"-- Выходи!",
		"-- Хорошо, я атакую!",
			code = [[ walk 'battle' ]];
		},
		{},
	}
}

battle = vnr {
	dsc = function(s)
		exec [[
			vn:show('images/fighter1.png', 'moveinright-right-middle', 500);
			vn:show('images/fighter2.png', 'moveinleft-left-middle@16,100', 500);
			vn:start()
		]]
		anton()
		pn [[Я плохо помню что произошло потом.]]
		pn ()
		exec [[
			vn:scene()
			vn.fading = 32
			vn:start('dissolve')
		]]
		pn [[Скорее всего, за меня работали мои рефлексы.]]
		pn ()
		pn [[Но я помню, что когда мои ракеты уже ушли в цель я успел удивиться...]]
		pn ()
		pn [[Почему он не стреляет?!]]
		pn ()
	end;
	walk_to = 'battle2';
}

battle2 = vnr {
	dsc = function(s)
		exec [[
			vn:scene 'box:800x600,white'
			vn.fading = 8
			vn:start 'dissolve'
		]]
		anton()
		pn [[... Он был пустым ...]]
		pn ()
	end;
	walk_to = 'epilog';
}

epilog = vnr {
	dsc = function(s)
		exec [[
			vn:scene 'images/sands2.jpg'
			vn.fading = 32
			vn:start 'fading'
		]];
		anton()
		pn [[Снова этот же старый сон.]]
		pn ()
		pn [[Много раз я думал, могло ли все случиться по другому?]]
		pn ()
		pn [[И он и я служили высшим целям, как мы думали...]]
		pn ()
		pn [[И каждый посутпил так, как должен был...]]
		pn ()
		pn [[Так я успокаивал себя, и в тоже время понимал, что обманываю себя.]]
		pn ()
		pn [[Он сказал, что новая клятва заставила его воевать.]]
		pn ()
		pn [[Моя присяга против его клятвы. Правда на правду.]]
		pn ()
		pn [[А может быть, ложь на ложь?]]
		pn ()
		pn [[Я не знаю...]]
		pn ()
		pn [[Но я больше не мог летать.]]
		pn ()
		pn [[И я дал новую, последнюю клятву.]]
		pn () 
		exec [[
			vn:scene 'images/sands.jpg'
			vn.fading = 32
			vn:start 'dissolve'
		]];
		pn [[Я поклялся Ему, и я знаю, что Он никогда не заставит меня убивать.]]
		pn ()
		pn [[А сейчас мне пора идти на молитву...]]
		pn ()
		exec [[
			vn:scene 'images/stars.jpg'
			vn.fading = 32
			vn:start 'fading'
			vn.bgalpha = 0
			set_music 'music/6.ogg'
		]];
		exec [[
			vn:show(spr_end, 'fadein-center-middle', 2000);
			vn:start ('fading')
		]];
	end;
}
